/*
 * libhttp -- uninformed research
 *
 * skape
 * mmiller@hick.org
 * 09/25/2002
 */
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#include "libhttp.h"

int main(int argc, char **argv)
{
	HTTP_REQUEST *request = httpRequestNew();
	HTTP_RESPONSE *response = httpResponseNew();
	char buf[64];
	unsigned char *fullBuffer;
	unsigned long fullBufferLength;
	char html[] = "<HTML><BODY><B>Hi.</B></BODY></HTML>";

	if (!request || !response)
		return 0;

	httpRequestInitialize(request, "GET", "/index.html", 1.1);
	httpRequestAttributeAdd(request, "Connection", "close", 1);
	httpRequestAttributeAdd(request, "Connection", "closing", 1);
	httpRequestAttributeAdd(request, "User-Agent", "Mozilla", 1);
	httpRequestAttributeAdd(request, "User-Agent", "Mozilla Not Overwritten", 0);
	httpRequestSetPayload(request, (unsigned char *)html, sizeof(html) - 1);

	fullBuffer = httpRequestGetFullBuffer(request, &fullBufferLength);

	if (fullBuffer)
	{
		fprintf(stdout,"request fullBuffer = %.8x, length = %lu:\n\n", (unsigned int)fullBuffer, fullBufferLength);

		write(1, fullBuffer, fullBufferLength);

		fprintf(stdout,"\n");

		httpRequestFreeFullBuffer(request, fullBuffer);	
	}
	else
		fprintf(stdout,"Could not get full buffer.\n");

	snprintf(buf, sizeof(buf) - 1, "%lu", (unsigned long)sizeof(html) - 1);

	httpResponseInitialize(response, 1.1, 404, "File Not Found");
	httpResponseAttributeAdd(response, "Content-Length", buf, 0);
	httpResponseSetPayload(response, (unsigned char *)html, sizeof(html) - 1);

	fullBuffer = httpResponseGetFullBuffer(response, &fullBufferLength);

	if (fullBuffer)
	{
		fprintf(stdout,"response fullBuffer = %.8x, length = %lu:\n\n", (unsigned int)fullBuffer, fullBufferLength);

		write(1, fullBuffer, fullBufferLength);

		fprintf(stdout,"\n");

		httpResponseFreeFullBuffer(response, fullBuffer);	
	}
	else
		fprintf(stdout,"Could not get full buffer.\n");

	return 1;
}
